#import "SillyBallView.h"

@implementation	SillyBallView	(Methods)		// ----------------------------------------------------------------------

enum {  kBallSize = 30 };

static float RandFloat(void)
    // Returns a random floating point number between 0.0 and 1.0.
 {
    return ((float) rand() / (float) RAND_MAX);
 }
static float RandGray(void)
    // Returns a random floating point number between 0.0 and 1.0.
 {
 int 	graySelector = (int)   ((float) rand() * 4 / (float) RAND_MAX);
 float	grayColor	 = NSWhite;
 
 	switch (graySelector) {
		case 0:		grayColor = NSWhite;
					break;
		case 1:		grayColor = NSLightGray;
					break;
		case 2:		grayColor = NSDarkGray;
					break;
		case 3:		grayColor = NSBlack;
					break;
	}
	
	return grayColor;	
 }
// ###############################################################################
- (void)drawRandomBallInside:(const NSRect *)rect;
    // See comment in interface part.
 {
 float x, y;
 // NSBezierPath *oval;

    // Calculate where the ball should go.
    
    x = rect->origin.x + rect->size.width * RandFloat();
    y = rect->origin.x + rect->size.height * RandFloat();

    // Set the current colour to a random RGB value.

	// ##################################################################
	//  For some good examples of Recoding an Object while it's running ...
	//   Here you can change the drawing implementation of   ... colors, sounds,  grayscale and erasers ...
	//   all good visual stuff ... :-))
	//   When you understand the code below ... try to change which lines are commented
	//   and then click "Load" when you want to try a new implementation
	// ##################################################################
	
	  [[NSColor colorWithDeviceRed:RandFloat() green:RandFloat() blue:RandFloat() alpha:1.0] set];
										// Try this for Colors
	//  PSsetgray(RandGray()); 					// Try this for randomGrays
	/// PSsetgray(NSLightGray);					// Try this for all lightGrays

	 NSRectFill(NSMakeRect(x, y, kBallSize, kBallSize));		// Try this to paint Rectangles
	// NSEraseRect(NSMakeRect(x, y, kBallSize, kBallSize));	// Try this when the View is full

	// NSBeep();  							 // try this if you are sound enabled ... 
	
	// Now set the current colour to black and draw
	// the text centred in the ball.
	
	// [[NSColor blackColor] set];					// Try change Text Color here ...
	   [[NSColor redColor] set];
	//    [[NSColor whiteColor] set];

	[textString drawAtPoint:NSMakePoint(x + kBallSize / 2 - textSize.width / 2,  y) withAttributes:nil];

	// ##################################################################
	// ##################################################################
 }
// ###############################################################################
- (id)initWithFrame:(NSRect)frameRect;
    // See comment in interface part.
 {
    self = [super initWithFrame:frameRect];
    if (self != nil) {

        // Init some basic instance variables.
        
        running = NO;
        textString = @"Bo3b";
        textSize = [ textString sizeWithAttributes:nil ];

        // Initialise the other instance variables,
        // and start the drawintg timer.
        
        [self setTimerPeriod:3 source:nil];
    }
    return (self);
 }

- (void)dealloc;
    // See comment in interface part.
 {
    [repeatTimer release];
    [super dealloc];
 }

//
- (void)setTimerRunning:(BOOL)run source:(id)source;
    // See comment in interface part.
 {
    if ( !running && run ) {

        // If we're not running and we've been told to run, we'd
        // better start the timer.  Set it up so that it calls
        // our drawAnother: method periodically to draw a ball.
        // The timer period is based on the repeatPeriod instance
        // variable (as controlled by the user via the Ball Rate
        // slider, which we feed into a maths function (real_time_
        // period = 10 ** - ball_rate_slider) to get a pleasing
        // non-linearity.
        
        repeatTimer = [[NSTimer scheduledTimerWithTimeInterval:pow(10, -repeatPeriod)
                            target:self
                            selector:@selector(drawAnother:)
                            userInfo:nil
                            repeats:YES
            	      ] retain];
        running = YES;
    } else if (running && !run) {

        // We're running and we've been told not to, so let's stop.
        
        [repeatTimer invalidate];
        [repeatTimer release];
        repeatTimer = nil;
        running = NO;
    }

    // Now update menu item to reflect any changes of running status.
    
    if (startStopMenuItem != nil) {
        if (running) {
            [ startStopMenuItem setTitle:@"Stop"];
        } else {
            [ startStopMenuItem setTitle:@"Start"];
        }
    }

    // Now set the value of the user interface based on the current repeat
    // period.  Two things to note here.  Firstly, we conditionalise
    // this by a test whether the view is not nil because the first
    // time we run (called from initWithFrame:) the views have not
    // yet been set up properly because we're being dearchived out
    // of a NIB file.  While it doesn't hurt to call methods on
    // nil objects (it's defined as a no-op in Objective-C), I wanted
    // to explicitly highlight this edge case.
    //
    // The second thing to notice is that we don't set the view
    // if it was the user interface element that prompted the change
    // (presumably it's already changed to the appropriately value).
    // This doesn't have a big effect in this specific case, but you
    // could imagine it causing weird effects in other cases.

    if (sliderView != nil) {
        if (sliderView != source) {
            [sliderView setFloatValue:repeatPeriod];
        }
    }
    if (textView != nil) {
        if (textView != source) {
            [textView setFloatValue:repeatPeriod];
        }
    }
 }

- (void)setTimerPeriod:(float)repPeriod source:(id)source;
    // See comment in interface part.
 {
    // Change the instance variable, then stop the repeat
    // timer (if it's running) and start it again with the
    // right period.
    
    repeatPeriod = repPeriod;
    if (running) {
        [self setTimerRunning:NO source:source];
    }
    [self setTimerRunning:YES source:source];
 }

//
- (void)drawRect:(NSRect)rect;
    // See comment in interface part.
 {
    // Do nothing.  In a normal view, you would update the visual
    // representation of your view inside this method.  However, SillyBallView
    // does not remember which balls that it's drawn, so there is nothing it
    // can draw in this meathd.  Instead the drawing happens asynchronously
    // inside the drawAnother: method.  See the notes in ReadMe.rtf for details.
 }

- (void)drawAnother:(id)timer;
    // See comment in interface part.
 {
    NSRect visRect;

    // Lock focus on ourselves.  We need to do this because we're drawing
    // outside of the context of NSView's drawRect: method.  This is relatively
    // unusual behaviour for a view.  See the discussion of this in ReadMe.rtf.
    
    [self lockFocus];

    // Now draw a random ball inside the view.
    visRect = [self visibleRect];
    [self drawRandomBallInside:&visRect];

    // And unlock the focus.
    [self unlockFocus];

    [[self window] flushWindow];
 }

- (void)forceRedraw:(id)source;
    // See comment in interface part.
 {
    [self setNeedsDisplay:YES];
 }

//
- (void)startOrStop:(id)sender;
    // See comment in interface part.
 {
    [self setTimerRunning:!running source:sender];
 }

- (void)setPeriod:(id)sender;
 // See comment in interface part.
 {
    [self setTimerPeriod:[sender floatValue] source:sender];
 }

@end
