
 // Don't edit - this file is a Generated output from ActiveDeveloper //
 // ----------------------------------------------------------------- //

#line 1
#import <Foundation/Foundation.h>
#import <AppKit/AppKit.h>

// Maximum number of tiles in the playing area...

#define NUMTILESX 8      
#define NUMTILESY 20

#define NUMTILETYPES 2   // Number of different tile types.

#define TILEHEIGHT	18.0  // Tile size, in pixels
#define TILEWIDTH	28.0				
#define INTERTILE	2.0

#define GAMEWIDTH  ((TILEWIDTH+INTERTILE) * NUMTILESX)  // Size of the field.
#define GAMEHEIGHT ((TILEHEIGHT+INTERTILE) * NUMTILESY)

/*
 BreakView.m, view to implement the "BreakApp" game.
 Author: Ali Ozer
 Written for 0.8 October 88. 
 Modified for 0.9 March 89.
 Modified for 1.0 July 89.
 Removed use of Bitmap and threw away some classes May 90.
 Final 2.0 fixes/enhancements Sept 90.
 3.0 update March 92.
 Sound-related changes for 3.1 March 92.
 Modified for 4.0 Jan 96
 Modified for Rhapsody June 97

 BreakView implements an interactive custom view that allows the user
 to play "BreakApp," a game similar to a popular arcade classic.

 BreakView's main control methods are based on the target-action
 paradigm; thus you can include BreakView in an Interface-Builder based
 application. Please refer to BreakView.h for a list of "public" methods
 that you should provide links to in Interface Builder.
 
 Copyright (c) 1988-1997 by Apple Computer, Inc., all rights reserved.

 You may incorporate this sample code into your applications without
 restriction, though the sample code has been provided "AS IS" and the
 responsibility for its operation is 100% yours.  However, what you are
 not permitted to do is to redistribute the source as "DSC Sample Code"
 after having made changes. If you're going to re-distribute the source,
 we require that you make it clear in the source that the code was
 descended from Apple Sample Code, but that you've made changes.
*/

@interface	BreakView  :  NSView	// #####################################
{
   int 			numTilesLeft, score, level, lives, highScore;
   BOOL 		gameRunning, demoMode, soundEnabled;

   NSTimer *		timer;
   NSTimeInterval 	lastFrameTime;

   // The various pieces that know how to draw themselves on the field.
   id 		tile[NUMTILETYPES];

   // The actual array of tiles on the field. tiles[x][y] is the id of the
   // tile that is at location x * TILEWIDTH, y * TILEHEIGHT.

   short	 tiles[NUMTILESX][NUMTILESY];
   id 		ball, paddle, backGround;

   // The following six are outlets set when the nib file is being read in.
   
   // Views that display various info (these can be nil, in which case the
   // corresponding info will just go to the bit bucket). 
   
   id 	scoreView;
   id 	livesView;
   id 	levelView;
   id 	hscoreView;
   id 	statusView;

   id	 wallSound;
   id	 tileSound;
   id	 paddleSound;
   id	 missSound;
   
   // Other ball & paddle params
   float 		ballX, ballY, paddleX, paddleY, ballXVel, ballYVel, leftMargin;

   NSSize	 ballSize, paddleSize, tileSize;

   // These variables store the of the ball. Killer ball goes through tiles
   // without bouncing; nice ball bounces from the top wall towards the paddle. 
   BOOL 	killerBall, niceBall;

   // Number of revolutions left if the ball is rotating. If zero or
   // less, than the ball is not rotating...
   float 		revolutionsLeft;
   float 		revolutionSpeed; // Radians per millisecond if rotating
}
@end
// Convert x-location to left/right pan for playing sounds

#import "BreakView+Defines.h"
#import "BreakView+Overridden.h"
#import "BreakView+Engine.h"
#import "BreakView+DrawingSound.h"
