#import "CalcController.h"
#import "Buttons.h"

@implementation	 OperationButton 	(Methods)	// ----------------------
- (void)performOperation:(int)operation with:sender;
 {
 id result = nil;

    if (operation == kNoOperator) return;
    
    if ( ([sender displayedNumber] == [NSDecimalNumber notANumber]) || ([sender enteredNumber] == [NSDecimalNumber notANumber]) )  {
       result = [NSDecimalNumber notANumber];
	
    } else {

        NS_DURING
            switch(operation)
              {
                case kAddOperator:     	result =  [[sender enteredNumber] decimalNumberByAdding: [sender displayedNumber]]; break;
                case kSubtractOperator: 	result =  [[sender enteredNumber] decimalNumberBySubtracting:  [sender displayedNumber]]; break;
                case kMultiplyOperator: 	result =  [[sender enteredNumber] decimalNumberByMultiplyingBy:  [sender displayedNumber]]; break;
                case kDivideOperator:   	result =  [[sender enteredNumber] decimalNumberByDividingBy:  [sender displayedNumber]]; break;
              };
        NS_HANDLER
          {
              // if get here, we either got a divide by zero, or an over/under flow exception
              // in any case, we return NAN
   	    result = [NSDecimalNumber notANumber];
          };
        NS_ENDHANDLER
    }

    [sender displayedNumber: result];
 }

- (void)performPolishOperation:(int)operation with:sender;
 {
 id result = nil;

    if (operation == kNoOperator) return;
    
    if ( ([sender displayedNumber] == [NSDecimalNumber notANumber]) || ([sender enteredNumber] == [NSDecimalNumber notANumber]) )  {
       result = [NSDecimalNumber notANumber];
	
    } else {

        NS_DURING
            switch(operation)
              {
                case kAddOperator:     	result =  [[sender polishPop] decimalNumberByAdding: [sender displayedNumber]]; break;
                case kSubtractOperator: 	result =  [[sender polishPop] decimalNumberBySubtracting:  [sender displayedNumber]]; break;
                case kMultiplyOperator: 	result =  [[sender polishPop] decimalNumberByMultiplyingBy:  [sender displayedNumber]]; break;
                case kDivideOperator:   	result =  [[sender polishPop] decimalNumberByDividingBy:  [sender displayedNumber]]; break;
                case kSpaceOperation:   	//[sender polishPush:  [sender displayedNumber]]; 
					[sender endEditingNumber];
					result = [sender displayedNumber]; 
					break;
                case kSwapOperation:   	result = [sender polishPop]; 
					[sender polishPush: [sender displayedNumber]]; 
					break;
              };
        NS_HANDLER
          {
              // if get here, we either got a divide by zero, or an over/under flow exception
              // in any case, we return NAN
   	    result = [NSDecimalNumber notANumber];
          };
        NS_ENDHANDLER
    }

    [sender displayedNumber: result];
 }

@end
